--[[
	CS2D Script made by Bowlinghead.
	Part of the "Buy Request" Script to emulate Valorants digital drop request system in CS2D
	Uploaded on UnrealSoftware.de
]]


--[[
	{
		[1] = {1,2,3,5} -- pistols
		[4] = {30, 32, 33} -- rifles
		...
	}
]]

-- Needs a valid text param similiar to link
-- Returns a lua table for storing buymenu info
-- https://www.cs2d.com/help.php?cat=all&cmd=mp_buymenu#cmd
function getBuyMenu(text)
	
	
	local result = {}
	local currentGroup
	local itemList = {}
	
	for groupContent in string.gmatch(text, "([^|]+)") do -- split on |
		
		
		
		for itemId in string.gmatch(groupContent, "([^,]+)") do -- split on , 
			table.insert(itemList, tonumber(itemId))
		end
		
		if (itemList[1] < 10) then
			currentGroup = 1
		elseif (itemList[1] < 20) then
			currentGroup = 2
		elseif (itemList[1] < 30) then
			currentGroup = 3
		elseif (itemList[1] < 40) then
			currentGroup = 4
		elseif (itemList[1] > 40) then
			currentGroup = 6
		else
			currentGroup = 5
		end
		
		
		result[currentGroup] = itemList;
		itemList = {}
	end
	return result;
end


function getGroups() 
	local groups = {}
	groups[1] = "Handgun"
	groups[2] = "Shotgun"
	groups[3] = "Sub Machine Gun"
	groups[4] = "Rifle"
	groups[5] = "Machine Gun"
	groups[6] = "Equipment"
	return groups;
end
groups = getGroups()

--[[
	
	{
		[0] = "Buy Menu, Pistols, Rifles, ..." -- all existing groups
		[1] = "Pistols, USP, Glock, Deagle, Elite" -- all items in group
		[2] = "Rifles, AK47, M4A1, Aug"
		...
	}
]]--

-- buyMenu Param = a lua table builded buy function getBuyMenu(text) 
-- returns a similiar menu but with strings, ready for use with cs2d:menu cmds
function getBuyMenuString(buyMenu)

	-- DEBUG print of buyMenu table
	print("*** Printing your buymenu table... ***")
	local txtList
	for k,list in pairs(buyMenu) do
		txtList = ""
		for _, item in pairs(list) do
			txtList = txtList..itemtype(item,"name").." ("..item.."),"
		end
		print("Group "..groups[k].." includes ids: "..txtList.." (amount: "..#buyMenu[k]..")")
	end
	


	local result = {}
	
	result[0] = "Ask For Drop"
	local resultItems = {}
	--[[for groupId, itemList in pairs(buyMenu) do
			print("------ "..groupId);
			result[0] = result[0]..','..groups[groupId]
			result[groupId] = "Buy - "..groups[groupId]
		
		
		for _, itemType in ipairs(itemList) do
			result[groupId] = result[groupId]..","..itemtype(itemType,"name").."|"..itemtype(itemType,"price").."$"
		end
	end]]
	
	local txt
	for groupId = 1, 6 do
		if (buyMenu[groupId] == nil) then
			txt = "" -- empty menu option if no items in current group
		else
			txt = groups[groupId];
			result[groupId] = "Buy - "..groups[groupId]
			
			for _, itemType in ipairs(buyMenu[groupId]) do
				result[groupId] = result[groupId]..","..itemtype(itemType,"name").."|"..itemtype(itemType,"price").."$"
			end
			
		end
		result[0] = result[0]..","..txt;
	end
	
	-- DEBUG print of string table
	--[[
	print("*** Printing your buymenu string table... ***")
	for i=0,6 do
		if (result[i] ~= nil) then
			print(i..": "..result[i])
		end
	end
	]]
	return result;
end

